



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Vue中使用webpack别名的方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Vue中使用webpack别名的方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 07:21:38 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在工作中，我们经常会写出这种代码：</p>
<pre class="prettyprint linenums"><code>import MHeader from '../../components/m-header/m-header'<br />
</code></pre>
<pre class="prettyprint linenums"><code>@import &quot;../../common/stylus/variable&quot;<br />
@import &quot;../../common/stylus/mixin&quot;<br />
</code></pre>
<p>即，需要引入公共文件，但是公共文件的文件路径里当前文件很远，那么就会形成上面示例中的那种路径很长的情况。</p>
<p>而因为文件目录是约定俗成的，不可轻易更改，无法修改相对路径。那么该怎么办呢？</p>
<p>大家都知道，Vue中的js可以通过配置webpack别名（alias）来避免一长串的路径引用，即：</p>
<pre class="prettyprint linenums"><code>// target<br />
import MHeader from 'components/m-header/m-header'

//webpack.base.conf.js<br />
alias: {<br />
    '@': resolve('src'),<br />
    'common': resolve('src/common'),<br />
    'components': resolve('src/components')<br />
}<br />
</code></pre>
<p>但是，如果直接把这种方法用在css中，则会报错：</p>
<pre class="prettyprint linenums"><code>@import &quot;common/stylus/variable&quot; 	// error<br />
@import &quot;common/stylus/mixin&quot;		// error<br />
</code></pre>
<p>其实，这种方法没有错，只不过webpack对css的处理不同于js。</p>
<p>在js中，webpack对路径进行处理时，自动将没有路径标识（/ ，./，../）的第一个文件夹名当做webpack别名处理。如，第一个文件夹名为<code>components</code>，那么webpack会自动在alias中搜索有没有对应的别名，如果有，则直接替换路径；没有则报错。</p>
<p>在css中，webpack正常情况下，不会对路径进行处理。如果你想让webpack对路径进行处理，那么，可以在路径前标识<code>~</code>，如下：</p>
<pre class="prettyprint linenums"><code>@import &quot;~common/stylus/variable&quot;<br />
@import &quot;~common/stylus/mixin&quot;<br />
</code></pre>
<p>相当于通过添加<code>~</code>表示common是webpack别名而不是表示一个文件夹名。</p>
<p>正确使用webapck别名可以大大缩短引入文件的时间。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k2gr8j.html">一步步开发自己的博客  &period;NET版（5、Lucenne&period;Net 和 必应站内搜索）</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwg0ml8.html">underscore 笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j3d4wq.html">Xshell中文乱码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw1mp38.html">Cocos2d-X3&period;0 刨根问底（八）----- 场景（Scene&rpar;、层&lpar;Layer&rpar;相关源码分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wd54vq.html">。。。Ajax的回调函数function&lpar;data&rpar;中，data的返回类型。。。</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okkpjx9.html">Java的内存回收机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wwe4xq.html">python中字典dict的操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnr5nrq.html">BNUOJ-26475 Cookie Selection 堆&comma;线段树等</a>
		</li>
						<li><a href="https://www.batexi.com/a/96orryv9.html">分享内容到微博、QQ空间、人人网、开心网等社区</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn36l2q.html">javascript 命名空间&comma;学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0k7z0q.html">IOS学习笔记06---C语言函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jwxwo8.html">用log&lpar;N&rpar;的解法实现数值的整数次方</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zjlyj9.html">Python：开发Sublime插件，方便PHP开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ypggn8.html">ubuntu配置LAMP</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1dk7zq.html">java使用iText生成pdf表格</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1g3jxq.html">hdu--1072--Nightmare（bfs回溯）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj26zxq.html">XCopy命令实现增量备份</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgpgpm8.html">打印机驱动冲突和端口异常：win10更新部分补丁后，打印机本地连接（连接打印机的主机）可以打印，其他共享网络中的电脑可以连接到打印机，但不能打印&mdash;&mdash;解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1g4jg9.html">Ideal test 不执行main方法了</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv73e28.html">未能找到 CodeDom 提供程序类型&OpenCurlyDoubleQuote;Microsoft&period;VJSharp&period;VJSharpCodeProvider&comma;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwl2vzk9.html">淘宝 NPM 镜像</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4e10pq.html">Architecture And Framework</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emvmdz9.html">jquery 之节点操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvk2ldq.html">Mac系统查看端口占用和杀死进程</a>
			</li>
						<li><a href="https://www.batexi.com/a/953omp08.html">绛河 初识WCF5</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkwjrd8.html">C&num; winform中 窗体缩放自适应的方法（不同电脑&sol;不同分辨率）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emvjwe9.html">Python初学者第十八天 函数（2）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnx734q.html">composer随笔</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2k4yx3q.html">vs中添加工具cmder并自动定位到当前目录</a>
			</li>
						<li><a href="https://www.batexi.com/a/953o7ez8.html">Socket Tools的使用</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
